var mDBGroupBy, mDBDisplayType, mDBMixedFilter, // Currently applied group / filter
mDBDestId, 									// Currently unfolded/to be unfolded details id
mDBDestIdUnfolded,							// Set to mDBDestId when unfolding has actually started
mDBData,									// Current selection data array
mDBNbItems;									// Nb of items in current selection;


/**
 * Init
 * @Param: pl: playlist content array
 */
function init(pl){
	plRefresh(pl);
	dgi('searchInput').focus();
	fAS('','refreshDisplay');
	connect(D.body,'mousemove',function(e){if(!e) e=W.event;if(e.shiftKey && e.ctrlKey && dgi('debugBt')) dgi('debugBt').style.display=''})
}

/**
 * Layout functions
 */
/*
Inlined function
function resizeDivs(){
	alignBottom(dgi('explorerDiv'),winMe,5);
	alignBottom(dgi('selectionDiv'),dgi('explorerDiv'),0);
	alignBottom(dgi('filterDiv'),dgi('explorerDiv'));
	// Reset margins of covers details
	if(mDBDestId && mDBDisplayType=='covers') coversDetailSetMargins(mDBDestId)
}
*/
function winResized(w,h){resizeDivs();}

/**
 * Adjust covers display type details div position
 */
function coversDetailSetMargins(destId){
	var s=dgi('det'+destId).style,n=dgi('id'+destId);
	s.marginLeft=(10-1*n.offsetLeft)+'px';
	s.width=(0.99*dgi("selectionDiv").offsetWidth-40)+'px';
	s.marginRight=(30-n.offsetLeft-dgi("selectionDiv").offsetWidth)+'px';
	s.display='';
}
// Function called on fold/unfold animation step. May be called with object id & animation step or with animation object only
function coversDetailSetMarginsWA(colId,step){
	// don't process when animation object is sent
	if(colId.item) return;
	if(mDBDisplayType==='covers') coversDetailSetMargins(colId.substr(3));
}

// Invisible cover IMG onload
function coverLoaded(n){
	if(n.offsetWidth==1) n.src=coverDefaultSrc; // 1x1 pixel = no cover => display default cover
	else if(mDBNbItems>40 || n.offsetWidth==0) n.style.visibility='' // Too many items or image width=0 (chrome WA on already cached images): display
	else fade(n,0,1,3) // Else fade-in
}

/**
 * User request a database update
 */
function updateDatabase(debug){
	fAS(false,'updateDatabase',debug,false,'sync')
}


function formatedTime(secs){
	if(!secs) return '-';
	var hours=Math.floor(secs/3600),minutes=Math.floor(Math.floor((secs%3600))/60),seconds=Math.floor(secs%60);
	if(hours>0 && minutes<10) minutes="0"+minutes;
	if(seconds<10) seconds="0"+seconds;
	if(hours>0) return hmsCaption.replace(/%1/,hours).replace(/%2/,minutes).replace(/%3/,seconds);
	else return msCaption.replace(/%1/,minutes).replace(/%2/,seconds);
}


/**
 * @desc: Insert img src into a template, using regular image template
 * @param t:
 * @param img: src of image, false to display default image
 * @param displayType: type of display, used to use correct img url template (with right size)
 */
function insertCover(t, img, displayType){
	var ct=coverTemplate;
	if(displayType.indexOf('Ext')>0) ct=coverTemplateLarge;

	if(img.length>0){
		if(sourceType=='iTunes') t=t.replace(/COVERSRC/g,ct).replace(/IMAGEPATH/,img.replace(/#/,lPID));
		else t=t.replace(/COVERSRC/g,ct).replace(/IMAGEPATH/,img);
	}
	else {
		t=t.replace(/COVERSRC/g,coverDefaultSrc)
	}
	t=t.replace(/EXTRAHTML=""/i,'width="'+fCW+'" height="'+fCW+'"');
	return t.replace(/imgtag/gi,'img');
}

// PLAY FUNCTIONS
function playTrack(trackId){view(trackId,dAWW,dAWH);}
function playAlbum(artistName, albumName){view('album/'+artistName+'/'+albumName,dAWW,dAWH)}
function playArtist(artistName){view('artist/'+artistName,dAWW,dAWH)}
function playPlaylist(playlistId){view('playlist/'+playlistId,dAWW,dAWH)}
function inlineSetSongPlayed(imgSrc,artist,album,title){
	dgi('inlinePlayerImg').src=imgSrc;
	dgi('inlineArtist').innerHTML=artist;
	dgi('inlineAlbum').innerHTML=album;
	dgi('inlineTitle').innerHTML=title;
}
function inlineUpdatePlayerInfo(trackId){fAS(trackId,'inlineUpdatePlayerInfo');}

// PLAYLIST FUNCTIONS
function plAddArtist(artistName){if(mIsProcessing) return; mProcessing(true);fAS(artistName,'plAddArtist');}
function plAddAlbum(artistName, albumName){if(mIsProcessing) return; mProcessing(true);fAS(artistName,'plAddAlbum',albumName);}
function plAddPlaylist(playlistId){if(mIsProcessing) return; mProcessing(true);fAS(playlistId,'plAddPlaylist');}
function plAddTrack(trackId){if(mIsProcessing) return; mProcessing(true);fAS(trackId,'plAddTrack');}
function plAddAllShuffle(){if(mIsProcessing) return; mProcessing(true);fAS(0,'plAddAllShuffle');}

// FILTER FUNCTIONS
function changeDisplayType(ndt){fAS(ndt,'changeDisplayType');}
function changeItemsPerPage(nb){fAS(nb,'changeItemsPerPage');}
function changeOffset(selectSeq){fAS(selectSeq,'changeOffset');}
function groupBy(item){
	dgi('groupBy'+item).checked="checked";
	fAS(item,'changeGroupBy');
}
function search(exp){
	searchValue=exp;
	dgi('groupBySearch').checked='checked';
	fAS(exp,'search');
}
function searchRealTime(exp){
	if(searchValue==exp) return;
	searchValue=exp;
	dgi('groupBySearch').checked='checked';
	fAS(exp,'search',1);
}
function validateSearch(e){
	if(e) kc=e.which; else {if(W.event) kc=W.event.keyCode; else return;}
	if(kc==13 && dgi('searchInput').value!="") search(dgi("searchInput").value);
	if(dgi('searchInput').value.length>2) searchRealTime(dgi('searchInput').value);
}

/**
 * Function called on user request to show Artist/Album/Playlist detail (or on click on already selected Artist/Album/Playlist).
 * 			this function is also called back by insertDetail function to display inserted content. In this case, only detailType && destId are provided
 */
function showDetail(detailType, artistName, albumName, destId, calledBackByInsertDetail){
	var n=dgi("det"+destId), pn=dgi('id'+destId), onSelf=(mDBDestId===destId);

	// If another detail is already shown, 1st collapse it
	if(mDBDestId && !calledBackByInsertDetail) {
		// If selected frame was the unfolded one, exit;
		if(onSelf) {
			// Collapse previously shown details (anim only if not collapsing because another one is opened)
			hideDetail(mDBDestId,mDBDestId!=destId);
			mDBDestId=false;
			return;
		}
	}

	mDBDestId=destId;

	// User-click (not server callback) Scroll to top of selected Album/Artist/Playlist
	if(!calledBackByInsertDetail) {
		//wl.fadeStyle('selectionDiv','scrollTop',dgi('id'+destId).offsetTop-((phpBrowser=='ie')?0:36),'exponential',10,'unfoldDetail()');
		unfoldDetail();
		// If content (already) loaded, wait for fadeStyle to callback unfoldDetail
		if(n.innerHTML!='') {
			$(pn).e.className().add('opened');
			return;
		}
	}
	else{
		// Server called back showDetail after having filled n.innerHTML, and scroll anim complete: unfold
		if(n.innerHTML!='' && mDBDestIdUnfolded==destId) unfoldDetail();
		$(pn).e.className().add('opened');
	}

	// Content not loaded: request to server
	if(!n.innerHTML){
		D.comForm.data1.value=albumName;
		fAS(artistName,'showDetail', destId, detailType);
		D.comForm.data1.value='*resSpecific*';
	}
}

function unfoldDetail(){
	var destId=mDBDestId,n=dgi("det"+destId);

	mDBDestIdUnfolded=mDBDestId;

	// If content not yet loaded, wait for 2nd callback
	if(!n.innerHTML) return;

	// Adjust position of detail node
	if(mDBDisplayType=='covers') coversDetailSetMargins(destId)


	// Cover view : adjust detail node margins so it fits overflow:scroll div's width
	coversDetailSetMarginsWA("col"+destId,'doneUnfold');
	// Unfold node
	dgi("col"+destId).style.display='inline';
	// Anim unfold (replaced by line above)
	//wl.nodeCollapseToggle("col"+destId,0,'coversDetailSetMarginsWA')

	if(W.toBeHiddenId) hideDetail(W.toBeHiddenId,1);
	W.toBeHiddenId=destId;

	//wl.fadeStyle('selectionDiv','scrollTop',dgi('id'+destId).offsetTop-((phpBrowser=='ie')?0:36),'exponential',10);
	wl.anim({
		'item':$('selectionDiv'),
		'duration':300,
		'function':function(p,anim){
			if(!p) {
				anim.startST=anim.item.scrollTop;
				anim.endST=dgi('id'+destId).offsetTop-((phpBrowser=='ie')?0:36);
			}
			p=wl.animFunctionUnfold3(p);
//cfDbg(Math.floor(100*p)+'/',1)
			anim.item.scrollTop=p*anim.endST+(1-p)*anim.startST
			return {}
		}
	});
}

/**
 * Fold details
 * Skip anim if unfolding another detail (prevents scroll positionning issues)
 * If anim skipped, destroy content to prevent other issues with absolute objects popping out of folded frame
 */
function hideDetail(nodeId,skipAnim){
	var s=dgi("col"+nodeId).style,n;
	s.height=((phpBrowser=='ie')?1:0)+'px';
	$("id"+nodeId).e.className().remove('opened');

	// Disabled unfold anim: force skipAnim to 0 to avoid a display issue
	if(0&&skipAnim) {
		s.visibility="hidden";s.margin=0;s.padding=0;
		dgi("det"+nodeId).innerHTML='';
	}
	else {
		dgi("col"+nodeId).style.display='none';
	}
	if(n=dgi('col'+nodeId+'BtMinus')){
		n.style.display='none';
		dgi('col'+nodeId+'BtPlus').style.display='';
	}
	W.toBeHiddenId=0;
}


/**
 * Insert into album/artist template the compact or detailed list of tracks
 * @param tracksData: array of tracks
 * @param displayType: 'full' (playlist detail) or 'compact' (all other details)
 */
function trackDetail(tracksData, displayType){
	var trackHTML,o,l=tracksData.length,trackData;
	// Template for single track
	var trackTemplate=dgi('trackDetail'+((displayType=='compact')?"Compact":"Full")).innerHTML;
	// Template for track group header
	var html=dgi('trackDetail'+((displayType=='compact')?"Compact":"Full")+'Header').innerHTML.replace(/&lt;/g,'<').replace(/&gt;/g,'>');
	// Template for track group footer
	var footerTemplate=dgi('trackDetail'+((displayType=='compact')?"Compact":"Full")+'Footer').innerHTML.replace(/&lt;/g,'<').replace(/&gt;/g,'>');

	// Create tracks HTML
	for(o=0;o<l;o++){
		trackData=tracksData[o];
		trackHTML=trackTemplate.replace(/TRACKTIME/,formatedTime(trackData[2])).replace(/TRACKNAME/g,trackData[1]).replace(/TRACKID/g,trackData[0]);
		trackHTML=trackHTML.replace(/ARTISTNAME/,trackData[3]).replace(/ALBUMNAME/g,trackData[4]).replace(/PARITY/,(o%2)?'odd':'even');
		html+=trackHTML.replace(/TRACKNUMBER/,o+1)
	}
	return html+footerTemplate;
}

/**
 * Show Artist/Album/Playlist detail
 * @param detailType: Artist/Album/Playlist
 * @param mixedDisplayType: Artist/Album/Playlist
 *
 */
function insertDetail(detailType, mixedDisplayType, destId, data){
	var albumTemplate,i,o,album,html="", tracksHtml='', aH='', artistName;

	if(detailType=='Artist'){
		artistName=dgi("name"+destId).innerHTML;
		albumTemplate=dgi("albumDetail"+mixedDisplayType.substr(7)).innerHTML;

		// Insert artist name header if existing (used for covers view)
 		if(dgi('detHeader'+destId)) html=dgi('detHeader'+destId).innerHTML.replace(/ARTISTNAME/,artistName);

		// Foreach album
		// Array(Album1 name, Album1 artwork, Album1 year, Album1 total time, Album1 nb tracks,
		//  							Array(
		// 	 							Array(Track1 PID, Track1 name, Track1 total time),
		//  								Array(Track2 PID, Track2 name, Track2 total time),
		//  								...
		//  						...),
		for(i=0;i<data.length;i++){
			album=data[i];
			aH=albumTemplate.replace(/ITEMID/g,'destId'+destId+'-'+i);
			aH=aH.replace(/ALBUMNAMEJS/g,album[0].replace(/'/g,"\\'"));	//"\
			aH=aH.replace(/ALBUMNAME/g,album[0]);
			aH=insertCover(aH,album[1],'default');
			aH=aH.replace(/YEAR/,album[2]);
			aH=aH.replace(/TOTALTIME/,formatedTime(album[3]));
			aH=aH.replace(/NBTRACKS/g,album[4]);
			aH=aH.replace(/ARTISTNAMEJS/g,artistName.replace(/'/g,"\\'"));	//"\
			aH=aH.replace(/ARTISTNAME/g,artistName);
			// Insert tracks
			tracksHtml=trackDetail(album[5],'compact');
			if(i==data.length-1) aH=aH.replace(/ENDSEPARATOR=""/i,'style="display:none"')
			html+=aH.replace(/TRACKS/,tracksHtml);
		}
	}

	if(detailType=='Album'){
		artistName=(dgi("artistName"+destId))?dgi("artistName"+destId).innerHTML:'';
		albumName=dgi("name"+destId).innerHTML;
		// Insert artist name header if existing (used for covers view)
		if(dgi('detHeader'+destId)) html=dgi('detHeader'+destId).innerHTML.replace(/ALBUMNAME/,artistName);

		html+=trackDetail(data,'compact');
		html=dgi('albumTrackDetailCompact').innerHTML.replace(/TRACKS/g,html);
	}
	if(detailType=='Playlist'){
		// Insert tracks
		html+=trackDetail(data,'full');
		html=dgi('albumTrackDetailCompact').innerHTML.replace(/TRACKS/g,html);
	}

	// Insert into detail node
	dgi("det"+destId).innerHTML=html;

	// Unfold / show
	showDetail(detailType,0,0,destId,1)
}

function updateSelect(selectArray){
	if(count(selectArray)==1) return dgi("selectionRange").innerHTML='';
	var html="";
	var txt="";
	for(var i=0;i<selectArray.length;i++){
		html+='<option value="'+i+'"'+((selectArray[i].substr(0,1)=='S')?' selected':'')+'>'+selectArray[i].substr(1)+'</option>';
	}
	if(selectArray.length>0) dgi("selectionRange").innerHTML='<select size="1" class="textInput" onChange="changeOffset(this.value)">'+html+'</select>'; else dgi("selectionRange").innerHTML='';
}


/**
 * MAIN ASYNC VIEW UPDATE FUNCTION
 *
 * @param groupBy: 'artist', 'album', 'playlist', 'track'
 * @param displayType: 'compact', 'full', 'cover', 'detail'
 * @param mixedFilter: groupBy+displayType
 * @param dataArray: array of artists and/or albums and/or playlists and/or tracks
 * @param selectArray: array needed for album/artist/playlist <select> update
 * @param currentOffset: offset in albums/artists/playlists
 * @param replace: true to replace view by generated one, false to add to currently displayed (used for mixed search results where displayList function is called once for every result type
 */
function displayList(groupBy, displayType,  mixedFilter, dataArray, selectArray, currentOffset, replace){
	var html='',i;
	mDBGroupBy=groupBy;
	mDBDisplayType=displayType;
	mDBMixedFilter=mixedFilter;
	mDBDestId=false;
	mDBData=dataArray;
	mDBNbItems=dataArray.length;

	// Update album/artist/playlist <select>
	if(replace) updateSelect(selectArray);

	// Build list HTML
	switch(groupBy){
		case "artist":
			for(i=0;i<dataArray.length;i++) html+=groupByArtist(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "album":
			for(i=0;i<dataArray.length;i++) html+=groupByAlbum(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "playlist":
			for(i=0;i<dataArray.length;i++) html+=groupByPlaylist(mixedFilter,dataArray[i],i+currentOffset);
			break;
		case "tracks":
			for(i=0;i<dataArray.length;i++) html+=groupByTrack(dataArray[i],i+currentOffset);
		default:
	}

	// Update view with created HTML
	if(replace) dgi("selectionDiv").innerHTML=html; else dgi("selectionDiv").innerHTML+=html;

	if(replace && dataArray.length==0) displayNoResults();
	//rebuildDraggableItems();
}

function displayNoResults(){
	dgi("selectionDiv").innerHTML=dgi("noSearchResult").innerHTML;
}

/**
 * Update View with a full/compact/covers view artist item
 * @param: displayType: "artistFull", "artistCompact", "artistCovers"
 * @item: array(artist name (0), nb of albums (1), nb of tracks (2), cover img src (3))
 * @index: sequential index
 */
function groupByArtist(displayType, item, index){
	if(displayType=='searchCompact') displayType='artistCompact';
	else if(!dgi("groupByA"+displayType.substr(1))) displayType='artistFull'; // Force all non-compact displays to artistFull

	// Get template
	var t=dgi("groupByA"+displayType.substr(1)).innerHTML

	t=t.replace(/ITEMID/g,"Artist"+index);
	t=insertCover(t,item[3],displayType);
	t=t.replace(/ARTISTNAMEJS/g,item[0].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[0]);
	t=t.replace(/NBTRACKS/,item[2]);
	t=t.replace(/PARITY/,(index%2)?' odd':' even');
	// If more than one track, show unfold button
	if(displayType=='artistCompact' && item[2]>1) t=t.replace(/hidden/,'')
	return t.replace(/NBALBUMS/,item[1]);
}


/**
 * Update View with a full/compact/covers view Album item
 * @param: displayType: "albumFull", "albumCompact", "albumCovers"
 * @item: array(album name (0), artist name (1), nb of tracks (2), total time (3), cover img src (4))
 * @index: sequential index
 */
function groupByAlbum(displayType, item, index){
	if(displayType=='searchCompact') displayType='albumCompact';
	else if(!dgi("groupByA"+displayType.substr(1))) displayType='albumFull'; // Force all non-compact displays to albumFull

	// Get template
	var t=dgi("groupByA"+displayType.substr(1)).innerHTML
	t=t.replace(/ITEMID/g,"Album"+index);
	t=insertCover(t,item[4],displayType);
	t=t.replace(/ARTISTNAMEJS/g,item[1].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ALBUMNAMEJS/g,item[0].replace(/'/g,"\\'"));	//foo.replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[1]);
	t=t.replace(/ALBUMNAME/g,item[0]);
	t=t.replace(/TOTALTIME/,formatedTime(item[3]));
	t=t.replace(/PARITY/,(index%2)?' odd':' even');

	// If more than one track, show unfold button
	if(displayType=='albumCompact' && item[2]>1) t=t.replace(/hidden/,'')
	return t.replace(/NBTRACKS/,item[2]);
}



/**
 * Update View with a independant track item (search result ?)
 * @item: array(track id (0), track name (1), album name (2), artist name (3), total time (4))
 * @index: sequential index
 */
function groupByTrack(item, index){
	t=dgi("trackGroup").innerHTML;
	t=t.replace(/ITEMID/g,"Tracks"+index);
	t=t.replace(/TRACKID/g,item[0]);
	t=t.replace(/ARTISTNAMEJS/g,item[3].replace(/'/g,"\\'"));
	t=t.replace(/ALBUMNAMEJS/g,item[2].replace(/'/g,"\\'"));
	t=t.replace(/ARTISTNAME/g,item[3]);
	t=t.replace(/ALBUMNAME/g,item[2]);
	t=t.replace(/TRACKNAME/g,item[1]);
	t=t.replace(/PARITY/,(index%2)?' odd':' even');
	return t.replace(/TRACKTIME/,formatedTime(item[4]));
}


/**
 * Update View with a full/compact/covers view Playlist item
 * @param: displayType: "playlistFull", "playlistCompact", "playlistCovers"
 * @item: array(playlist id (0), playlist name (1), nb of tracks (2))
 * @index: sequential index
 */
function groupByPlaylist(displayType, item, index){
	var t=dgi("groupByPlaylistCompact").innerHTML;
	t=t.replace(/ITEMID/g,"Playlist"+index);
	t=t.replace(/PLAYLISTID/g,item[0]);
	t=t.replace(/PLAYLISTNAME/g,item[1]);
	t=t.replace(/PARITY/,(index%2)?' odd':' even');
	t=t.replace(/PLDELDISPLAY/,(item[3])?'inline':'none');
	return t.replace(/NBTRACKS/,item[2]);
}

D.onkeyup=validateSearch;