<?php

/**
 * @desc Return data for misc parameters block
 *
 * @return array(title,content,action)
 */
function uiConfigBlockMisc(){
	$title=outImage(outIcon('configMisc'),false,false,'vertical-align:top;margin-right:1em').cfCaption('genMisc');

	$content='<div style="position:absolute;width:100%;top:50%;margin-top:-1em;left:0">';
	$content.=cfCaption('activityLogActivity').', '.cfCaption('acFileExplorerSettings').', '.cfCaption('acLoginParameters').'...';
	$content.='</div>';
	$content.=outImage(outIcon('UI/configRight'),false,false,'position:absolute;right:10px;bottom:10px');
	$action="showFrame('misc',1,0)";

	return array('title'=>$title,'content'=>$content,'action'=>$action);
}

/**
 * @desc misc. parameters configuration items
 *
 */
function uiConfigFrameMisc(){
	global $resourceData;

	echo outDivframe('frame1');
	?>
	<div class="frame1Header"><?php
	uiConfigAdvancedConfigButton('misc');
	echo outImage(outIcon('configMisc'),false,false,'margin-right:0.5em;vertical-align:middle').cfCaption('genMisc');
	?>
	</div>
	<?php
	echo outConfigSeparator();

	// Activity & content logging
	echo outImageIcon('log');
	rcProcessData('logUserActivity',dataBoolean,true,false,cfCaption('activityLogActivity'),false);
	echo '<br><br>';


	// Beta versions
	echo '<div style="float:right">';
	echo outImageIcon('beta');
	rcProcessData('installBeta',dataBoolean, false, false,cfCaption('configInstallBetas'),false);
	echo '</div>';


	// Updates
	echo outImageIcon('appUpdate');
	rcProcessData('checkUpdates',dataBoolean, true, false, cfCaption('startCheckForUpdates'),false);
	echo outImageIcon('right');

	// Action on new version
	echo '<span style="white-space:nowrap">';
	rcProcessData('updateApplication',dataList,'confirm',array(/*'disabled',*/'confirm','auto'),array(
		array(false,cfCaption('acUpdateApplication')),array(
			/*array('disabled',cfCaption('genDisabled')),*/
			array('confirm',cfCaption('genConfirm')),
			array('auto',cfCaption('genAutomatic'))
		),
		false),true);
	echo '</span><br>';

	if($reg=cfRegistrationData()){
		// Use of short URI format for direct links
		echo '<br>';
		echo outDivFrame('frame2');
		echo '<div class="frame2Header">'.cfCaption('genDirectLink').'</div><br><b>'.cfCaption('genFormat').'</b><br>';
		$defaultLength=cfGGetVar('directLinkLength');
		if(!is_numeric($defaultLength) || $defaultLength<3) $defaultLength=cfConstant('SHORT_LINK_DEFAULT_SIZE');

		$fakeShortLink=substr('a4dsiw45ponbp2w',0,cfConstant('SHORT_LINK_DEFAULT_SIZE'));
		$fakeLongLink='directResourceAccessToken=uawd9hE7ZtpZms4UtsnsSbM9bHbHud';

		rcProcessData('directLinkLength',dataList,$defaultLength,array($defaultLength,"0"),
			array(
				array("&nbsp;&nbsp;",$defaultLength,cfCaption('shortLink').'<div class="altText">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.cfSiteLink().'/'.$fakeShortLink.'</div>'),
				array(" ","0",cfCaption('longLink').'<div class="altText">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.cfSiteLink().'?'.$fakeLongLink.'</div>')
			),
			true);
		echo '</div>';
	}


	/***************************************************************************************************************************
	 *  Advanced config section
    ***************************************************************************************************************************/
	echo uiConfigAdvancedFrameHeader('misc');

		/**
		 * LOGIN SETTINGS
		 */
		echo outDivFrame('frame3');
		echo '<div class="frame3Header">'.outImage(outIcon('restricted'),false,false,'vertical-align:middle;margin-right:1em').cfCaption('acLoginParameters').'</div>';


		rcProcessData('RSAAuthorizedDelay',dataNumeric,60,array(1,2048),array(cfCaption('acRSAAuthorizedDelay'),1, cfCaption('genSeconds')),true,false);

		rcProcessData('loginKeyLength',dataNumeric,384,array(128,2048),array(cfCaption('acLoginKeyLength'),1, ' bits'),true,false);


		rcProcessData('waitTimeBetweenLoginAttemtps',dataNumeric,1,array(0,3600),array(cfCaption('acWaitTimeBetweenLoginAttemtps'),1, cfCaption('genSeconds')),true,false);


		rcProcessData('passwordCheckMaxAttempts',dataNumeric,3,array(1,2048),array(cfCaption('acPasswordCheckMaxAttempts'),1),true,false);


		rcProcessData('passwordCheckBanPeriod',dataNumeric,120,array(1,2048),array(cfCaption('acPasswordCheckBanPeriod'),1, cfCaption('genMinutes')),false,false);
		if(file_exists(cfAppDataDir().'/connectionAttempts.txt')) echo outBt(cfCaption('genClear'),false,"javascript:dgn('commandSent').value='resetPasswordCheckBanPeriod';dgn('configForm').submit();");

		echo '<br><br>';

		rcProcessData('disableClientSessionIPControl',dataBoolean, false, false, cfCaption('acDisableClientSessionIPControl'), true, false);

		rcProcessData('disablePasswordCipheringForSlowJSDevices',dataBoolean, true, false, cfCaption('acDisablePasswordCipheringForSlowJSDevices'), true, false);

		rcProcessData('inactivityTimeBeforeDisconnect',dataNumeric,121,array(9,999999999),array(cfCaption('acInactivityTimeBeforeDisconnect'),2, cfCaption('genSeconds')),true,false);

		rcProcessData('logoutToLoginPage',dataBoolean, false, false, cfCaption('acLogoutToLoginPage'), true, false);

		echo '</div><br/>';

		/**
		 * EXPLORER SETTINGS
		 */
		echo outDivFrame('frame3');
		echo '<div class="frame3Header">'.outImage(outIcon('lockedFolder'),false,false,'vertical-align:middle;margin-right:1em').cfCaption('acFileExplorerSettings').'</div>';

		// Files rating
		echo outImageIcon('sel');
		rcProcessData('ratingAllowed',dataBoolean, true, false, cfCaption('ratingAllowed'), true, false);

		rcProcessData('transferRefreshRate',dataNumeric,5,array(1,2048),array(cfCaption('acTransferRefreshRate'),1, cfCaption('genSeconds')),true, false);

		// Download resume tokens
		rcProcessData('downloadTokenLifetime',dataNumeric,172800,array(0,9999999999),array(cfCaption('acDownloadTokenLifetime'),4, cfCaption('genSeconds')),true, false);

		// Max upload file size
		rcProcessData('uploadMaxFilesize',dataNumeric,0,array(8,1024),array(cfCaption('configUploadMax'),3,' (8-1024)'.cfCaption('genSizeMb')),false,false,array('apply'=>1));

		echo '<br><br>';

		rcProcessData('generalHideUnallowedFiles',dataBoolean, true, false, cfCaption('acGeneralHideUnallowedFiles'), true, false);

		rcProcessData('protectSensitiveFiles',dataBoolean, true, false, cfCaption('acProtectSensitiveFiles'), true, false);

		rcProcessData('protectedFilesExtensions',dataText, 'php,asp,htaccess', false, array(cfCaption('acProtectedFilesExtensions'),15), true, false);
		echo '<br>';
		rcProcessData('protectSensitiveFolders',dataBoolean, true, false, cfCaption('acProtectSensitiveFolders'), true, false);

		rcProcessData('generalExecuteProtection',dataBoolean, false, false, cfCaption('acGeneralExecuteProtection'), true, false);

		rcProcessData('generalDownloadProtection',dataBoolean, false, false, cfCaption('acGeneralDownloadProtection'), true, false);

		rcProcessData('generalWriteProtection',dataBoolean, false, false, cfCaption('acGeneralWriteProtection'), true, false);

		rcProcessData('generalModifyProtection',dataBoolean, false, false, cfCaption('acGeneralModifyProtection'), true, false);

		rcProcessData('generalShowHiddenFiles',dataList,'admin',array('all','admin','none'),array(
		array(false,cfCaption('acGeneralShowHiddenFiles')),array(
		array('all',cfCaption('genEverybody')),
		array('admin',cfCaption('photoCfgCEAdmin')),
		array('none',cfCaption('genNobody'))
		),false),true);

		rcProcessData('generalShowSystemFiles',dataList,'all',array('all','admin','none'),array(
		array(false,cfCaption('acGeneralShowSystemFiles')),array(
		array('all',cfCaption('genEverybody')),
		array('admin',cfCaption('photoCfgCEAdmin')),
		array('none',cfCaption('genNobody'))
		),false),true);

		rcProcessData('generalAllowReadOnlyFilesOverwrite',dataList,'none',array('all','admin','none'),array(
		array(false,cfCaption('acGeneralAllowReadOnlyFilesOverwrite')),array(
		array('all',cfCaption('genEverybody')),
		array('admin',cfCaption('photoCfgCEAdmin')),
		array('none',cfCaption('genNobody'))
		),false),true);

		echo '<br><br>';


		echo '<br>'.outImageIcon('tooltip');
		rcProcessData('tooltipFileInfo',dataBoolean, true, false, cfCaption('acTooltipEnabled'), true, false);

		echo '</div><br>';

		// Thumbnails
		echo outDivFrame('frame3');
			echo '<div class="frame3Header">'.outImageIcon('thumbnail').cfCaption('genThumbnails').'</div>';
			rcProcessData('disableCreateJPG',dataBoolean, false, false, cfCaption('acDisableCreateJPG'), true, false);
			echo '<br>';
			rcProcessData('thumbnailJPGQuality',dataNumeric, 70, array(1,100), array(cfCaption('acThumbnailJPGQuality'),1,'%'), true, false);
			echo '<br>';
			rcProcessData('imageResampleQuality',dataNumeric, 1, array(1,5), array(cfCaption('acImageResampleQuality'),1), true, false);
		echo '</div>';

	echo '</div>';
	echo '</div>';
}
