<?php
/**
 * User Interface Configuration tab
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.1.0F
 */
if(!cfIsInApp()) die('Unauthorized access');

wSession_write_close(false);


/**
 * @desc Generic wrapper for frames
 *
 * @param string $frameName: name of frame (see $panels)
 */
function uiStartFrame($frameName){
	global $panels;
	$item=$panels[$frameName];

	// Positionning div
	echo '<div class="uiStartPosDiv" style="top:'.$item['top'].'%;left:'.$item['left'].'%;width:'.$item['width'].'%;height:'.$item['height'].'%">';

	// Selectable block
	if(@$item['notSelectable']) echo '<div id="uiStartBlock_'.$frameName.'" onclick="'.$item['action'].'" class="uiStartBlockUnsel not">';
	else echo '<div id="uiStartBlock_'.$frameName.'" class="uiStartBlockUnsel" onmouseover="uiStartSel(this,1)" onmouseout="uiStartSel(this,0)" onclick="'.$item['action'].'">';

	// Content
	echo $item['content'];
	echo "</div></div>\n\n";
}

/**
 * @desc Display divs needed for mouse over detection and transparent background (IE...)
 *
 * @param string $unselColor: b or w
 * @param integer $unselOpacity: 0-100
 * @param string $selColor: b or w
 * @param integer $selOpacity: 0-100
 * @return string
 */
function uiStartTransparentBg($unselColor='b', $unselOpacity=10, $selColor='w', $selOpacity=70){
	$selBg=(($selColor=='w')?'white;':(($selColor=='b')?'black;':$selColor.';'));
	$unselBg=(($unselColor=='w')?'white;':(($unselColor=='b')?'black;':$unselColor.';'));
	$out='<div class="uiStartBgUnsel" style="background:'.$unselBg.outCssOpacity($unselOpacity).'"></div>';
	$out.='<div class="uiStartBgSel" style="background:'.$selBg.outCssOpacity($selOpacity).'"></div>';
	return $out;
}

/**
 * @desc Resources frame
 *
 * @return string
 */
function frameShare(){
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.cfCaption('genResources').'</div>';
	$out.='<div class="content"><img style="float:left;margin:2px 4px 0 0" src="'.outIcon('UI/startShare').'">'.cfCaption('startResourceDet').'</div>';
	return $out;
}

/**
 * @desc Resources frame
 *
 * @return string
 */
function frameSend(){
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.outImageIcon('directLink').cfCaption('doSend').'</div><div class="content">'.cfCaption('directLinkExpl').'</div>';
	return $out;
}

/**
 * @desc Resources frame
 *
 * @return string
 */
function framePublish(){
	$out=uiStartTransparentBg('w',85,'w',50);
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.outImageIcon('publish').cfCaption('doPublish').'</div><div class="content">'.cfCaption('publishVideoLabel').', '.cfCaption('publishResourceLabel').', '.cfCaption('publishDownloadLabel').', '.cfCaption('publishSocialLabel').'</div>';
	return $out;
}

/**
 * @desc Server frame
 *
 * @return string
 */
function frameServer(){
	$out='';
	// Title
	$out.='<div class="uiTabTitle" style="position:absolute;top:0px;right:10px">'.cfCaption('mainStartButton').'</div>';

	// Server block
	$out.='<div style="position:absolute;left:0px;top:60px;z-index:10">';

		// Logo
		$out.=outImage(outIcon('serverOnline'),false,false,'margin-right:5px;vertical-align:top;float:left');
		$out.='<fieldset><b style="color:black">';

		// Server range
		if(!cfIsAsync() && strpos(file_get_contents(cfAppDataDir().'/httpd.conf'),'#onLAN')) $out.=cfCaption('apacheStartedLocal');
		else $out.=cfCaption('apacheStartedWeb');
		$out.=/*outImageIcon('ok',false,'margin-left:0.5em').*/'</b><br>';

		// URL
		$url=cfPublicURL();

		$out.='<a class="link" target="_blank" href="'.$url.'" style="position:relative;top:5px">'.$url.'</a><br>';
		//$out.='<a class="link" target="_blank" href="'.$url.'" style="position:relative;top:5px;filter:progid:DXImageTransform.Microsoft.Glow(Color=#505050,Strength=1);zoom:1;color:white;text-shadow:#000 0px 0px 2px">'.$url.'</a><br>';

		// Server access test button
		$out.='&nbsp;'.outBt(cfCaption('startTestServerAccess'),false,"javascript:wl.UICommand('testServerAccess')",false,false,'style="position:relative;top:10px"');
	$out.='</fieldset></div>';

	// Lower frame
	$out.='<div style="position:absolute;left:0;bottom:0;padding:0px;width:100%;cursor:auto">';

	// Application site link
	$out.='<a style="float:right" class="link" target="_blank" href="'.APP_SITE.'">'.str_replace('http://','',APP_SITE).'</a>';

	// App version
	$out.='<div style="position:relative">'.str_replace(' ','&nbsp;',cfCaption('genVersion').cfCaption('genSeparator').cfGGetVar('appVersion')).'</div></div>';

	return $out;
}

/**
 * @desc Groups frame
 *
 * @return string
 */
function frameGroups(){
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out=uiStartTransparentBg('w',85,'w',65);

	// User icons
	$nb=0; $icons='<div style="position:absolute;right:3px;top:3px;width:90%;height:90%;text-align:right">';
	$out.=uiStartTransparentBg('#F9F9F9',80,'b',7);
	foreach (WEnv::userConfigs() as $id=>$user){
		$icons.='<img alt="" src="/gfx/icons/'.$user->getVar('icon').'" style="widtha:40px;height:20%">';
		if(++$nb>2) break;
	}
	$icons.='</div>';

	$out.='<div class="frame2Header" style="position:absolute;top:5px;left:10px">'.cfCaption('genGroups').'</div>';
	$out.=$icons;
	$out.='<div style="z-index:1;position:absolute;top:50%;margin-top:-4em;font-size:120%">'.cfCaption('startUserDet').'</div>';
	return $out;
}

/**
 * @desc Configuration frame
 *
 * @return string
 */
function frameConfig(){
	$out='';
	// Transparent
	$out.=uiStartTransparentBg('w',85,'w',74);
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.cfCaption('mainConfigButton').'</div>';
	$out.='<div style="z-index:1;position:absolute;top:50%;margin-top:-2em;font-size:120%">'.cfCaption('startConfigDet').'</div>';
	$out.=outImage(outIcon('UI/startConfig'),false,false,'z-index:1;position:absolute;bottom:5px;right:5px');
	return $out;
}

/**
 * @desc Activity frame
 *
 * @return string
 */
function frameActivity(){
	$out=uiStartTransparentBg('white',90,'white',70);
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.cfCaption('mainActivityButton').'</div>';
	$out.='<div class="content">'.cfCaption('startActivityDet').'</div>';
	$out.=outImage(outIcon('UI/startActivity'),false,false,'position:absolute;bottom:3px;right:3px');
	return $out;
}

/**
 * @desc community frame
 *
 * @return string
 */
function frameCommunity(){
	$out=uiStartTransparentBg('w',90,'white',70);
	$out=uiStartTransparentBg('#F9F9F9',80,'b',7);
	$out.='<div class="frame2Header">'.cfCaption('genCommunity').'</div><div class="content">'.cfCaption('startContactDet').'</div>';
	return $out;
}


require(INCLUDE_DIR.'outputFunctions.php');
require(INCLUDE_DIR.'resourceConfigFunctions.php');

// Echo backgound image
if(isset($_GET['bg'])){
	WHeaders::contentType('jpg'); WHeaders::cache();
	die(base64_decode(file_get_contents(cfAppDocRoot().'/gfx/UI/startBg2.bin')));
}

/**
 * @desc Return a list of all 5 panels with properties
 *
 * @return array
 */
function uiStartFramePanels(){
	$panels=array(
		'share'=>array(
			'content'=>frameShare(),
			'action'=>"uiStartGo('share','uiResources.php?tab=share')",
			'icon'=>outIcon('startRes'),
			'left'=>0,
			'top'=>0,
			'width'=>40,
			'height'=>25
		),
		'send'=>array(
			'content'=>frameSend(),
			'action'=>"uiStartGo('send','uiResources.php?tab=send')",
			'icon'=>outIcon('startRes'),
			'left'=>0,
			'top'=>25,
			'width'=>20,
			'height'=>25
		),
		'publish'=>array(
			'content'=>framePublish(),
			'action'=>"uiStartGo('publish','uiResources.php?tab=publish')",
			'icon'=>outIcon('startRes'),
			'left'=>20,
			'top'=>25,
			'width'=>20,
			'height'=>25
		),
		'user'=>array(
			'content'=>frameGroups(),
			'action'=>"uiStartGo('user','uiUsers.php')",
			'icon'=>outIcon('startUser'),
			'left'=>40,
			'top'=>0,
			'width'=>40,
			'height'=>50
		),
		'config'=>array(
			'content'=>frameConfig(),
			'icon'=>outIcon('startConfig'),
			'action'=>"uiStartGo('config','uiConfig.php')",
			'left'=>0,
			'top'=>50,
			'width'=>40,
			'height'=>50
		),
		'activity'=>array(
			'content'=>frameActivity(),
			'action'=>"uiStartGo('activity','uiActivity.php')",
			'left'=>40,
			'top'=>50,
			'width'=>40,
			'height'=>25
		),
		'community'=>array(
			'content'=>frameCommunity(),
			'action'=>"uiStartGo('community','uiCommunity.php')",
			'left'=>40,
			'top'=>75,
			'width'=>40,
			'height'=>25
		),
		'server'=>array(
			'content'=>frameServer(),
			'action'=>false,
			'notSelectable'=>true,
			'left'=>80,
			'top'=>0,
			'width'=>20,
			'height'=>100
		)
	);
	return $panels;
}


$panels=uiStartFramePanels();


/**
 ***************************************************************************************************************************
 * Display page
 ***************************************************************************************************************************
 */
cfInsertHEAD(false);
?>
</head>
<body style="margin:0;overflow:hidden" id="uiStartBody">
<input type="hidden" id="UIScript" name="UIScript" onkeyup="eval(this.value)">
<?php
echo outLoadMask(false); if(!cfIsAsync()) flush();
// <img style="width:100%;height:100%;position:absolute;left:0;top:0" src="/gfx/UI/uiBg2.jpg">
?>
<style type="text/css">
.frame2Header{font-size:170%;position:absolute;top:5px;left:10px}
.content{position:absolute;top:40%}
</style>
<?php
/**
 * Frames
 */
foreach ($panels as $panelId=>$panel) echo uiStartFrame($panelId);

echo cfScriptLink('wz_dragdrop.js');
?>
<script type="text/javascript">
var ids=<?php echo json_encode(array_keys($panels));?>, blocks=[];

function winResized(){
	var i,b,pb,w,h;

	if(!blocks.length) for(i=0;i<ids.length;i++) blocks[i]=dgi("uiStartBlock_"+ids[i]);

	for(i=0;i<blocks.length;i++) {
		b=blocks[i];
		pb=b.parentNode;
		w=pb.offsetWidth;
		h=pb.offsetHeight;
		b.style.width=(w-((phpBrowser=="ie")?5:20))+"px";
		b.style.height=(h-((phpBrowser=="ie")?5:20))+"px";
	}
}

// Block effect
function uiStartSel(n,s){
	var c=$(n).e.className();
	if(s){c.remove('uiStartBlockUnsel');c.add('uiStartBlockSel')} else{c.remove('uiStartBlockSel');c.add('uiStartBlockUnsel')}
}

// Block clicked
function uiStartGo(pName,url){
	if(W.parent && W.parent.uiMain)  W.parent.uiMain.tabSelect(url,pName);
	else {
		if(pName=='share'||pName=='send'||pName=='publish')	wl.UICommand('selectPanel:resource/'+pName); else wl.UICommand('selectPanel:'+pName);
	}
}
connect(W,'resize',winResized)
winResized();
</script>
</body>