<?php
/**
 * RSS feed viewer
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.4.0
 */

require(INCLUDE_DIR.'mobileFunctions.php');

$isAdmin=WEnv::user()->isAdministrator();

// Get an array with all blog's messages. This array is used for previous/next buttons and for history
$allMessages=getMessagesList(false,false);
$messages=getMessagesList($dateTo, $dateFrom);


/*
 ***************************************************************************************************************************
 * Process POST commands
 ***************************************************************************************************************************
 */
if(isset($_POST['action']) && $_POST['action']=='showComments'){
	cfAsyncHeader();
	$key=substr($_POST['value'],3);
	if(isset($messages[$key])){
		$html='<div class="frame2Header">'.cfCaption('blogComments',count($comments=getCommentsList($messages[$key]))).'</div>';
		foreach ($comments as $comment){
			$html.='<div class="frame3"><div class="frame3Header">'.cfCaption('blogCommentTitle',$comment['author']).'</div>';
			$html.=$comment['body'];
			$html.='<br><br>';
			if(isset($comment['eMail'])) $html.=outMailSafe($comment['eMail'],0).'<br>';
			if(isset($comment['link'])) {
				if(strtolower(substr($comment['link'],0,4))!='http') $link='http://'.$comment['link']; else $link=$comment['link'];
				$html.='<a href="'.$link.'" target="_blank">'.cfUTF8Encode($comment['link']).'</a>';
			}
			$html.='</div>';
		}
		if($html) echo cfAsyncXMLInnerHTMLbyId($html,$_POST['value']);
	}
	echo cfAsyncXMLJSaction('wl.liUnsel("'.$_POST['value'].'")');
	die(cfAsyncFooter());
}


/*
 ***************************************************************************************************************************
 * Insert HEAD, FORMS and JAVASCRIPT functions
 ***************************************************************************************************************************
 */
$editBt=($isAdmin)?mfButton(false,'javascript:newMsgShow(1)',outIcon('edit')):'';
$delBt=($isAdmin)?mfButton(false,'javascript:toggleDel()',outIcon('cancel32Select'),'style="margin-right:1em"'):'';
mfInsertHead(array('topControlsExtra'=>$delBt.$editBt));
?>
<form name="miscAction" action="index.php" enctype="multipart/form-data" method="POST" style="display:none;">
<input name="action" id="action" type="hidden">
<input name="value" id="value" type="hidden">
<input type="hidden" name="resId" value="<?php echo $_SESSION['activeResourceId']; ?>">
</form>

<script type="text/javascript">
function mas(a,v,s){
	if(s) return sendData('action='+a+'&value='+v);
	dgi("action").value=a;
	dgi("value").value=v;
	D.forms.miscAction.submit();
}
function sc(nid){mas('showComments',nid,1)}
function goMsg(ts){mas('prevNext',ts);}
function deleteMsg(id){if(confirm("<?php echo cfCaption('blogConfirmDelete');?>")) mas('delete',id)}
function toggleExtra(){dgi('wbE').style.display=(dgi('wbE').style.display)?'':'none'}
function newMsgShow(v){
	toggleExtra();dgi('newMsgForm').style.display=(v)?'':'none'; dgi('blogBody').style.display=(v)?'none':'';if(v) dgn('newMessageTitle').focus()
}
function newMsgSend(){dgi('newMsgForm').submit()}
function toggleDel(){var i,db=D.getElementsByName('delBt');for(i=0;i<db.length;i++) db[i].style.display=(db[i].style.display)?'':'none';}
function showNewComment(id){
	toggleExtra();
	dgn("messageID").value=id;
	dgn("newCommentForm").style.display="";
	dgi("blogBody").style.display="none";
}
function hideNewComment(id){
	toggleExtra();
	dgn("newCommentForm").style.display="none";
	dgi("blogBody").style.display="";
}
function sendComment(){
	var f=D.forms.newCommentForm;
	if(!f.newCommentAuthor.value || !f.newCommentBody.value) return alert('<? echo cfCaptionJS('genFillFields');?>');
	f.submit();
}
function commentKD(e){
	if(wl.eventKC(e)==13) sendComment();
}
</script>
<?php

/**
 * New post form
 */
if($isAdmin){
?>
<form id="newMsgForm" method="POST" enctype="multipart/form-data" style="display:none">
<div class="wide" style="margin:0 auto 0 auto">
<div class="frame1Header"><?php echo cfCaption('genTitle');?></div>
<input type="text" name="newMessageTitle" style="width:100%"><br>

<div class="frame1Header"><?php echo cfCaption('explorerFileSendMessage');?></div>

<textarea style="width:100%;height:10em" name="newMessageBody"></textarea>
</div>
<br><br>
<center>
<?php
	echo mfButton(cfCaption('genOK'),'javascript:newMsgSend()',false,false,false,array('extraClass'=>'green wide'));
	echo '<br>';
	echo mfButton(cfCaption('genCancel'),'javascript:newMsgShow(0)',false,false,false,array('extraClass'=>'red wide'));
	echo '</center></form>';
}

/**
 * Comments form
 */
if(cfRGetVar('commentsAllowed')){
	$name=htmlentities(cfUTF8Encode(WEnv::user()->name()),ENT_QUOTES);
	if(WEnv::user()->accountType()!='anonymous') $readonly=' readonly ';else $readonly='';
?>
<form name="newCommentForm" method="POST" enctype="multipart/form-data" style="display:none">
<div class="wide" style="margin:0 auto 0 auto">
<div class="frame1Header"><?php echo str_replace(':','',cfCaption('genAuthor',''));?></div>
<input type="text" name="newCommentAuthor" style="width:100%" <?php echo $readonly?> value="<?php echo $name;?>"><br>
<br>
<div class="frame1Header"><?php echo cfCaption('explorerFileSendMessage');?></div>

<input type="text" name="newCommentBody" style="width:100%" onkeyup="commentKD(event)"></textarea>
<input name="messageID" type="hidden">
</div>
<br><br>
<center>
<?php
	echo mfButton(cfCaption('genOK'),'javascript:sendComment()',false,false,false,array('extraClass'=>'green wide'));
	echo '<br>';
	echo mfButton(cfCaption('genCancel'),'javascript:newMsgShow(0)',false,false,false,array('extraClass'=>'red wide'));
	echo '</center></form>';
}
echo '</center>';
// Messages
echo '<div class="frame1" id="blogBody">';
if(!count($messages)) die('<div style="position:absolute;top:45%;text-align:center;width:100%">'.cfCaption('blogNoPost').'</div>');

// Get timestamps of 1st and last post
$minMax=getMinMaxDate();


// "Next messages" button
if($minMax){
	reset($messages); // position on first (most recent) of displayed messages
	if(getTimeStamp(current($messages)->getAttribute('date'))<$minMax['max']){ // If this message is not the most recent
		// Find this message in entire messages list.
		reset($allMessages); for($i=0;$i<count($allMessages);$i++) {if(current($allMessages)->getAttribute('date')==current($messages)->getAttribute('date')) break; next($allMessages);}
		// Move maxPostPerPage steps backward
		 for($i=0;$i<cfRGetVar('maxPostPerPage');$i++) @prev($allMessages); if(!current($allMessages)) reset($allMessages);
		 $nextTS=getTimeStamp(current($allMessages)->getAttribute('date'));
		// Display button
		echo mfListTable();
		echo mfListItem('onclick="goMsg('.$nextTS.')"','&nbsp;',false,cfCaption('blogNextPosts'),false,outImage(outIcon('medUp')),false).'</table>';
	}
}


/**
 * Display messages
 */
$nbDisplayedMessages=0;
foreach ($messages as $key=>$message){
	if(cfRGetVar('maxPostPerPage') && cfRGetVar('maxPostPerPage') <= $nbDisplayedMessages) break; // Limit number of displayed messages

	// Message date
	$postDate=cfCaption('blogPosted',cfUTF8Encode(date(cfCaption('blogPostedDateFormat'), getTimeStamp($message->getAttribute('date')))));

	// Title & delete button
	if($isAdmin) $del=mfButton('','javascript:deleteMsg('.$message->getAttribute('ID').')',outIcon('cancel32'),'id="supprBt'.$message->getAttribute('ID').'" style="display:none" name="delBt"'); else $del='&nbsp;';
	if(cfRGetVar('commentsAllowed')) $newCommentButton=mfButton('','javascript:showNewComment('.$message->getAttribute('ID').')',outIcon('blogAddComment')); else $newCommentButton='';

	echo mfListTable(false,'h1');
	echo mfListItem(false,
		$del.'&nbsp;','style="width:1px"',
		'<div class="lit">'.$message->getElementsByTagname('title')->item(0)->nodeValue.'</div>'.$postDate, false,
		$newCommentButton
	);
	echo '</table>';

	// Top image
	$body=$message->getElementsByTagname('body')->item(0);
	$image=$message->getElementsByTagname('image');
	if($image->length && $image->item(0)->hasAttribute('position') && $image->item(0)->hasAttribute('fileName') && $image->item(0)->getAttribute('position')=='top') echo '<center>'.outImage(cfAppResourceDir().'/'.$image->item(0)->getAttribute('fileName')).'</center>';

	// Message body
	echo $body->nodeValue;

	// Bottom image
	if($image->length && $image->item(0)->hasAttribute('position') && $image->item(0)->hasAttribute('fileName') && $image->item(0)->getAttribute('position')=='bottom') echo '<center>'.outImage(cfAppResourceDir().'/'.$image->item(0)->getAttribute('fileName')).'</center>';

	echo "<br><br>\n";

	// Comments
	if(cfRGetVar('commentsAllowed') && count($comments=getCommentsList($message))){
		//echo '<div class="frame2" id="cmt'.$key.'" onclick="sc(this)"><div class="frame2Header">'.outImage(outIcon('medPlus'),false,'class="ico"').cfCaption('blogComments',count($comments)).'</div></div>';
		echo '<div id="cmt'.$key.'">';
		echo '<div style="text-align:right">';
		echo mfButton(cfCaption('blogComments',count($comments)),"javascript:sc('cmt".$key."')",outIcon('medPlus'));
		echo '</div>';
		echo '</div>';

	}

	echo "<br>\n";


	$nbDisplayedMessages++;
}

// "Previous messages" button
if($minMax){
	reset($messages); for($i=1;$i<cfRGetVar('maxPostPerPage');$i++) @next($messages); // Position on last (oldest) message
	if(!current($messages)) end($messages); // If $messages contains less than maxPostPerPage, go to last message

	if(getTimeStamp(current($messages)->getAttribute('date'))>$minMax['min']){ // If this message is not the most recent
		// Find this message in entire messages list.
		reset($allMessages);
		for($i=0;$i<count($allMessages);$i++) {
			if(current($allMessages)->getAttribute('date')==current($messages)->getAttribute('date')) break;
			next($allMessages);
		}
		@next($allMessages); // Move one step forward
		$previousTS=getTimeStamp(current($allMessages)->getAttribute('date'));
		// Display button
		echo mfListTable();
		echo mfListItem('onclick="goMsg('.$previousTS.')"','&nbsp;',false,cfCaption('blogPreviousPosts'),false,outImage(outIcon('medDown')),false).'</table>';
	}
}
?>
</div>
</body>
</html>