<?php
/**
 * External embeded website
 *
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2007 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.8
 */

/*
 ***************************************************************************************************************************
 * Verify config rights
 ***************************************************************************************************************************
 */
rcConfigRights();

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

// Resource icon & name
rcInsertIconName($resourceData);


echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('genURL').'</div>';



// Base folder
rcProcessData('url',dataText,APP_SITE,false,outIcon('fi/icoXml'));
echo '</div>';


// Separator ***************************************************************************
echo outConfigSeparator();


// Default Window state
echo rcThemeSelectionControl(false,array('noThemeControl'=>1));

// Open resource in separate window
rcProcessData('separateWindow',dataBoolean,false,false,outImageIcon('win').cfCaption('musicPopupPlayer'));


// Save / cancel buttons
echo '<br/>'.rcButtonSaveCancel();

// Indicate that resource has been initialized
rcProcessData('resourceConfigured',dataBoolean,true,false,false/*do not display control*/);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);
?>
<script language="javascript" type="text/javascript">
function dataChanged(dataName,dataValue){
	if(dataName=="fixedSize"){
		if(!dgn("fixedSize").checked) {
			dgn("winInnerWidth").disabled=true;
			dgn("winInnerHeight").disabled=true;
		}
		else{
			dgn("winInnerWidth").disabled=false;
			dgn("winInnerHeight").disabled=false;
		}
	}
	if(dataName=='url'){
		if(dataValue.match(/^(((ht|f)tp(s?))\:\/\/)?(([a-zA-Z0-9]+([@\-\.]?[a-zA-Z0-9]+)*)(\:[a-zA-Z0-9\-\.]+)?@)?(www.|ftp.|[a-zA-Z]+.)?[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,})(\:[0-9]+)?\/?/g))
			dgn('url').style.color='';
		else
			dgn('url').style.color='red';
	}
}
<?php
if(!$resourceData["fixedSize"]) echo 'dataChanged("fixedSize",false);';
?>
dataChanged("url",$resourceData["url"]);
</script>