<?php
/**
 * Proxy Browser : Browser frames
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
*
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.8
 */
require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'proxyFunctions.php');

function debugTraceReplaceCB($prev,$new){echo cfAsyncXMLInnerHTMLbyId($new,'debugTraceReplace');}

/**
 * Mobiles devices not supported
 */
if(cfIsMobile('iPhone')) {require_once(INCLUDE_DIR.'mobileFunctions.php');mfDisplayResourceNotCompatiblePage();}


/*
 ***************************************************************************************************************************
 * Init proxy data
 ***************************************************************************************************************************
 */
if(!cfRGetVar('parametersLoaded')){
	cfRSetVar('history',0,cfRGetVar('startPageURL'));
	cfRSetVar('historyIndex',0);
	cfRSetVar('debug',1);
	cfRSetVar('debugTraceReplace',0);
	cfRSetVar('parametersLoaded',true);

	// Debug: correct output directory if needed
	if(cfRGetVar('debugDirectory') && substr(cfRGetVar('debugDirectory'),-1)=='/') cfRSetVar('debugDirectory',substr(cfRGetVar('debugDirectory'),0,strlen(cfRGetVar('debugDirectory'))-1));
	// Add a character at begining for strpos
	if(cfRGetVar('debugExt')) cfRSetVar('debugExt',' '.cfRGetVar('debugExt'));
}

$history=cfRGetVar('history');
$historyIndex=cfRGetVar('historyIndex');

/*
 ***************************************************************************************************************************
 * Process POST Command
 ***************************************************************************************************************************
 */
cfAsyncXMLChangePhpVarValue('debugTraceReplace','debugTraceReplaceCB');

if(isset($_POST['checkEncodedURL'])){
	cfAsyncHeader();
	echo cfAsyncXMLJSaction('prompt("Source","'.proxyDecodeUrlPHP($_POST['checkEncodedURL']).'")');
	die(cfAsyncFooter());
}

if(isset($_POST['newURL'])){
	cfAsyncHeader();
	if($_POST['newURL']=='prev'){
		if($historyIndex>0) $historyIndex--;
		echo cfAsyncXMLInnerHTMLbyId($history[$historyIndex],'tmpURL');
		echo cfAsyncXMLJSaction('dgi("address").value=dgi("tmpURL").innerHTML');
		echo cfAsyncXMLJSaction('goURL()');
	}
	elseif($_POST['newURL']=='next'){
		if($historyIndex<count($history)-1) $historyIndex++;
		echo cfAsyncXMLInnerHTMLbyId($history[$historyIndex],'tmpURL');
		echo cfAsyncXMLJSaction('dgi("address").value=dgi("tmpURL").innerHTML');
		echo cfAsyncXMLJSaction('goURL()');
	}
	elseif($_POST['newURL'] && $history[$historyIndex]!=$_POST['newURL']){
		$history[++$historyIndex]=$_POST['newURL'];
		while(count($history)>$historyIndex+1) unset($history[count($history)-1]);
	}
	if($historyIndex==0) echo cfAsyncXMLJSaction('btDisable("prevBt")'); else echo cfAsyncXMLJSaction('btEnable("prevBt")');
	if($historyIndex==count($history)-1) echo cfAsyncXMLJSaction('btDisable("nextBt")'); else echo cfAsyncXMLJSaction('btEnable("nextBt")');

	cfRSetVar('history',$history);
	cfRSetVar('historyIndex',$historyIndex);

	die(cfAsyncFooter());
}

// Proxy base URL
$_ENV['baseURLProxy']=cfHostName().dirname($_SERVER['PHP_SELF']).'/';


/*
 ***************************************************************************************************************************
 * Insert HEAD, JS functions and form (no top header for iPhone)
 ***************************************************************************************************************************
 */
cfInsertHEAD(false,array('noExtraHeader'=>1));
?>
<script type="text/javascript" src="/js/proxyScripts.js"></script>
<script type="text/javascript">
var baseURLProxy="<?php echo $_ENV['baseURLProxy'];?>";
var watchURLInterval;
var currentURL="<?php echo $history[$historyIndex];?>";
var currentTitle=" ";
var focused=true;
function resizeProxyFrame(){
	dgi('mainTable').style.height='100%';
}
function addressKeyPress(e){
	return;
	if((window.event && (event.keyCode==13 || event.keyCode==10) && event.ctrlKey) || (e && e.keyCode==13 && e.ctrlKey)){
		dgi('address').value='www.'+dgi('address').value+'.com';
		goURL();
	}
}
function goURL(target){
	if(!target) target='proxyFrame';

	if(!dgi('address').value) dgi('browser').action="<?php echo dirname($_SERVER['PHP_SELF']).'/aboutBlank.php';?>";
	else dgi('browser').action=proxyEncodeURL(dgi('address').value,true);

	dgi('browser').target=target;
	if(dgi('sourceFrame')) dgi('sourceFrame').src=dgi('address').value;
	dgi('browser').submit();
}
function goSrcURL(){
	dgi('browser').action=dgi('address').value;
	dgi('browser').target='_blank';
	dgi('browser').submit();
}
function addressFocus(){
	focused=true;
	dgi('address').select();
}
function updateURL(){
	if(frames['proxyFrame'].document.title!=currentTitle) {
		currentTitle=frames['proxyFrame'].document.title;
		winMe.setCaption('Proxy Browser - '+currentTitle);
	}
	if(frames['proxyFrame'].siteHref && frames['proxyFrame'].siteHref.href!=currentURL){
		dgi('address').value=frames['proxyFrame'].siteHref.href;
		currentURL=dgi('address').value
		if(dgi('address').value==null) alert(document.frames['proxyFrame'].location.href);
		dgn('newURL').value=currentURL;
		asyncSubmitForm('updateURLForm',false);
	}
}
function prevURL(){
	dgn('newURL').value='prev';
	asyncSubmitForm('updateURLForm',false);
}
function nextURL(){
	dgn('newURL').value='next';
	asyncSubmitForm('updateURLForm',false);
}
function test(){
	//alert(decodeURL(dgi('proxyFrame').location.href));
}
var a=0;
function adressKD(e){
	if(window.event) {
		kc=window.event.keyCode;
		ctrl=window.event.ctrlKey
	}
	else{
		kc=e.which;
		ctrl=e.ctrlKey
	}
	//alert(dbgObj(window.event))
	if((kc==13 || kc==10)&& ctrl) {
		if(a==1) alert(dgi('address').value.substr(0,3))

		if(dgi('address').value.substr(0,3)!='www')	dgi('address').value='www.'+dgi('address').value+'.com';
	}
	if(kc==13 || kc==10) goURL();
}
function debugFrames(s){
	if(s==0) {dgi('proxyFrame').style.width="0%";dgi('proxyFrame').style.display="none";   dgi('sourceFrame').style.width="95%";dgi('sourceFrame').style.display="inline"}
	if(s==1) {dgi('proxyFrame').style.width="47%";dgi('proxyFrame').style.display="inline";dgi('sourceFrame').style.width="47%";dgi('sourceFrame').style.display="inline";}
	if(s==2) {dgi('proxyFrame').style.width="95%";dgi('proxyFrame').style.display="inline";dgi('sourceFrame').style.width="0%"; dgi('sourceFrame').style.display="none";}
}
</script>
<style type="text/css">
#address {padding-left:24px;background:url('/favicon.ico');background-repeat:no-repeat; background-position:4px 0px}
#browser {margin-bottom:0.3em}
a{text-decoration:none;font-weight:bold}
</style>
</head>
<body onresize="resizeProxyFrame()" onload="goURL()">
<form id="updateURLForm" name="updateURLForm" style="display:none" action="<?php echo $_SERVER['PHP_SELF'];?>">
	<input type="text" name="newURL">
</form>
<div id="tmpURL" style="display:none"></div>
<?php echo outTableTransparent('frame1','height:100%','id="mainTable" border=0 height="100%"');?>
<tr>
	<td height="1">
		<div class="frame1">
		<form id="browser" method="POST" enctype="multipart/form-data"  target="proxyFrame" action="proxy.php" onsubmit="goURL()">
		<?php echo outBt(false,outIcon('prev'),'javascript:prevURL()','prevBt',false,false,(($historyIndex)?'up':'off')); ?>
		<?php echo outBt(false,outIcon('next'),'javascript:nextURL()','nextBt',false,false,(($historyIndex!=count($history)-1)?'up':'off')); ?>
		<?php echo outBt(false,outIcon('stop'),'javascript:windowStop()','nextBt'); ?>
		<?php echo outBt(false,outIcon('change'),'javascript:document.frames(\'proxyFrame\').location.reload()','nextBt'); ?>

		<input id="address" type="text" class="textInput" size="50%" value="<?php echo $history[$historyIndex];?>" onfocus="addressFocus()" onkeydown="adressKD(event)" >

		<?php echo outButton(false,'javascript:goURL(\'proxyFrame\')',outIcon('right')); ?>
		<?php //echo outButton('Open in new window','javascript:goURL(\'_blank\')',outIcon('playlist')); ?>
		<?php //echo outButton('Open source','javascript:goSrcURL()',false); ?>
		<?php //echo outButton('','javascript:void(sendData(\'debugTraceReplace=\'+(1-dgi(\'debugTraceReplace\').innerHTML),\''.$_SERVER['PHP_SELF'].'\'))',outIcon('addMult.png')).'<span id="debugTraceReplace">'.cfRGetVar('debugTraceReplace').'</span>';
		//if(cfRGetVar('debug')) echo '<input onchange="sendData(\'checkEncodedURL=\'+this.value,\''.$_SERVER['PHP_SELF'].'\')" size=4>';
		?>
		</form>
		</div>
	</td>
</tr><tr>
	<td>
		<?php if(false && cfRGetVar('debug')) {?>
		<iframe id="proxyFrame" name="proxyFrame" src="proxy.php" style="width:95%;height:100%;border:0px"></iframe>
		<fieldset style="background:#DDF;height:100%;width:10px;display:inline;vertical-align:top"><legend> </legend>
			<a href="javascript:debugFrames(0)">&lt;</a><br><br>
			<a href="javascript:debugFrames(1)">||</a><br><br>
			<a href="javascript:debugFrames(2)">&gt;</a>
		</fieldset>
		<iframe id="sourceFrame" name="sourceFrame" src="proxy.php" style="width:0%;height:100%;border:0px;display:none"></iframe>
		<?php
		}
		else{
			?>
			<iframe id="proxyFrame" name="proxyFrame" src="proxy.php" style="width:100%;height:100%;border:0px"></iframe>
			<?php
		}
		?>
	</td>
</tr>
</body>
<script type="text/javascript">
dgi('address').onkeypress=addressKeyPress;
watchURLInterval=window.setInterval('updateURL()',500);
</script>