<?php
/**
 * COMMON MOBILE DEVICES LOGIN FORM
 *
 * Included by login.php
 * Display login form
 *
 * Use 2 variables :
 *
 * string $userToDisplaySeqNumber : id of pre-selected user
 * boolean $wrongPasswordSent : true if an incorrect password has been sent
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.1.1
 */

require(INCLUDE_DIR.'mobileFunctions.php');


// number of forms to be displayed
$nbForms=count($_ENV['users']);
// sequential number of pre-selected form
if(isset($userToDisplay)){
	$i=0;
	foreach ($_ENV['users'] as $key=>$value) {if($key===$userToDisplay) $userToDisplaySeqNumber=$i;	$i++;}
}
elseif (isset($_ENV['users'][0])){
	$userToDisplay=0;
	$userToDisplaySeqNumber=0;
}
else {
	if($nbForms==1){foreach ($_ENV['users'] as $key=>$value) {$userToDisplay=$key; $userToDisplaySeqNumber=0;}} else $userToDisplaySeqNumber=-1;
}

// If direct resource access, hide name input area, and fill user name with directResourceAccessToken
if(isset($_ENV['directResourceAccessToken'])) {
	$defaultUserName='dRA:';
	$groupInputLabel='';
	$groupInputIcon='<img src="/gfx/appIcon.png">';
	$directResourceAccessPasswordHas=false;

	// Browse resources to find passed token and get resource name
	foreach (WEnv::resConfigs() as $rid=>$res){
		if($res->getVar('directResourceAccessToken')==$_GET['directResourceAccessToken']) {
			$groupInputIcon=outImageIcon($res->icon32());
			$groupInputLabel='<div class="lit">'.str_replace('<','&lt;',str_replace('>','&gt;',cfUTF8Encode($res->getVar('name')))).'</div>';
			break;
		}
	}

}
else {
	$groupInputLabel=cfCaption('genGroup');
}



/*
 ***************************************************************************************************************************
 * Async Response
 ***************************************************************************************************************************
 */
if(cfIsAsync() && isset($_POST['user'])){
	echo cfAsyncHeader();
	// If security issue detected, display error message
	if($securityEvent)echo cfAsyncXMLJSaction('dgi("securityEvent").innerHTML="'.str_replace('"',"''",($securityEvent)).'";');
	echo cfAsyncXMLJSaction('resetInputs();');
	if($wrongPasswordSent || $wrongUserSent){
		$errorText=str_replace('"',"''",(($wrongUserSent)?cfCaption('loginBadPasswordOrAccount'):cfCaption('loginBadPassword')));
		echo cfAsyncXMLJSaction('dgi("wrongPassword").innerHTML="'.$errorText.'";dgi("encryptPerc").innerHTML=""');
	}
	//echo cfAsyncXMLJSaction('if(dgi("password'.$userToDisplaySeqNumber.'")) dgi("password'.$userToDisplaySeqNumber.'").focus();');
	echo cfAsyncXMLJSaction('wl.mask.hide()');
	cfAsyncFooter();
}


// Insert HTML Head and Javascript
mfInsertHEAD(array('ping'=>false,'context'=>'login'));

echo cfScriptLink('loginMobile.js',true);

?>
<script language="JavaScript" type="text/javascript">
var nbUsers=<?php echo count($_ENV['users']);?>;
<?php echo cfJSCaptionVar('passwordCrypt'); ?>
<?php echo cfJSCaptionVar('loginConnectButton'); ?>
</script>
<?php

// Insert Login form and RSA encryption scripts and HTML
includeLoginFormAndScripts(false);

// Table used for vertical & middle alignment

// Login Frame
echo '<DIV class="frame1">';

// Login message
if(cfGGetVar('loginMessage')) echo '<div class="loginMessage">'.cfUTF8Encode(cfGGetVar('loginMessage'),false,false).'</div>';

?>
<table class="liTable" cellspacing=0 cellpadding=0>
<tr style="line-height:4px;height:4px;font-size:6px;overflow:hidden;visibility:hidden" class="liSel"><td class="lil">&nbsp;</td><td class="lic"> </td><td class="lir"></td></tr>
<?php
$i=0;

/*
 * Direct Resource Access
 */
if(isset($_ENV['directResourceAccessToken'])) {
	echo mfListItem('id="dRAItem" onclick="sDRA()"',$groupInputIcon,false,$groupInputLabel.'<br><div id="ePN"></div>','',outImage(outIcon('go'),false,'id="rIcon"'));
	?>
<script language="JavaScript" type="text/javascript">
function sDRA(){
	try{var img=new Image();img.src="/themes/mobile/common/loading.gif"} catch(e){}
	var ePN=dgi('ePN'),pwd=prompt("<?php echo cfCaptionJS('genPassword');?>","");
	if(pwd===null) return; // Cancel
	if(!pwd) return sDRA();

	dgi("dRAItem").className='liSel';
	dgi("rIcon").src="/themes/mobile/common/loading.gif";

	var dle=D.loginForm.elements;
	dle['userId'].value='dRA:';
	dle['user'].value='dRA:';
	dle['password'].value=pwd;
	dgi("wrongPassword").innerHTML="&nbsp;";
	startEncryption();
}
function resetInputs(){
	dgi("dRAItem").className='li';
	dgi("rIcon").src="<?php echo outIcon('go');?>";
	if(dgi("encryptionLockSend")) dgi("encryptionLockSend").style.display="none";
}
W.addEventListener('load',sDRA,true)
</script>
	<?php
}

/*
 * Users list
 */
else {
	echo '<div id="groupsList">';

	foreach($_ENV['users'] as $key=>$value){

		if($value['name']) $name=str_replace('<','&lt;',str_replace('>','&gt;',cfUTF8Encode($value['name'])));
		else $name=cfCaption('genGroup');
	//if(!(@$value['accountType'])) cfVarDump($value);

		/**
		 * User name td
		 */
		echo '<tr class="li" id="tr'.((int)$i).'"';
		//if(!$value['name'] && count($_ENV['users'])==1) echo ' style="display:none"'; // If there is only hidden groups, don't show "other groups"

		// Password value
		if($value['authenticationMethod']==='noAuthentication') $password=0;
		elseif ($value['authenticationMethod']==='facebook') $password="'facebook'";
		elseif ($value['authenticationMethod']==='list') $password="'list'";
		else $password=1;

		// Onclick action
		echo ' onclick="javascript:sU('.$i.',\''.((isset($value['hint']) && strlen($value['hint'])>0)?cfProtectInlineScriptTextArg($value['hint']):'').'\',\''.(($value['name'])?cfProtectInlineScriptTextArg($value['name']):'').'\','.$password.',\''.(($value['name'])?(cfUTF8Encode($value['name'])):cfCaption('loginOtherGroup')).'\')">';
		echo "<td class=\"lil\">\n";

		// Hidden user id
		echo '<span id="userId'.((int)$i).'" style="display:none">'.$key.'</span>';


		// User icon
		if(@$value['accountType']=='facebook') $ico=' style="background-position:0 -96px"';
		elseif(@$value['accountType']=='singleUser') $ico='';
		elseif(@$value['accountType']=='list') $ico=' style="background-position:0 -32px"';
		else $ico='style="background-position:0 -64px"';
		echo '<div class="loginUser"'.$ico.'>';
		if(!@$value['authenticationMethod'] || $value['authenticationMethod']=='password') echo '<div class="loginUser lock" style="background-position:0 -128px;position:absolute;top:13px;left:16px"></div>';
		echo '</div>';

		echo '</td><td class="lic">';

		// User Name
		echo'<div class="lit">';
		if($value['name']) echo cfStrTruncate($name,30);
		else echo cfCaption('loginOtherGroup');
		echo '</div><div id="pi'.$i.'">&nbsp;</div></td>'."\n";

		// Submit
		echo '<td class="lir"><b class="goIco"></b></td></tr>';
		$i++;
	}
	echo '</div>';
}
?>
</table>
<span id="wrongPassword" class="warning" style="margin-left:3em"><?php echo ((@$wrongPasswordSent)?cfCaption('loginBadPassword'):'&nbsp;');?></span>
</div>
<div style="position:absolute;top:10px;right:10px;color:red; text-align:right" id="securityEvent"><?php echo ((@$securityEvent)?($securityEvent):'');?></div>
<?php

/**
 * SubUser / Password box
 */
?>
<div id="loginPwdDiv" style="display:none" class="form">
<center>
<div id="loginNameGroup">
<input id="loginNameInput" type="text" class="wide" placeholder="<?php echo cfCaption('genGroup');?>">
<br>
<br>
</div>
<div id="loginSubUserGroup">
<input id="loginSubUserInput" type="text" class="wide" placeholder="<?php echo cfCaption('genUsername');?>">
<br>
<br>
</div>
<input type="password" id="loginPwdInput" class="wide" onchange="setTimeout(sUPwdProceed,200)" placeholder="<?php echo cfCaption('genPassword');?>">
<br>
<br>
<div id="loginPwdHint"></div>
<div id="loginBts">
<?php
// Validate password input button
echo mfButton(cfCaption('loginConnectButton'),'javascript:sUPwdProceed()',false,'id="okBt"',false,array('extraClass'=>'wide green'));
echo '<br>';
// Cancel password input button
echo mfButton(cfCaption('genCancel'),'javascript:pwdShow(0);wl.liUnselAll()',false,false,false,array('extraClass'=>'wide red'));
?>
</div>
</center>
</div>
<?php
// If there is a single user with password, display password input now
if(count($_ENV['users'])==1){
	if($value['authenticationMethod']=='password'){
		echo '<script type="text/javascript">sU(0,\''.((isset($value['hint']) && strlen($value['hint'])>0)?cfProtectInlineScriptTextArg($value['hint']):'').'\',\''.(($value['name'])?cfProtectInlineScriptTextArg($value['name']):'').'\','.$password.',\''.(($value['name'])?cfProtectInlineScriptTextArg($value['name']):'').'\')</script>';
	}
}
// Set screen height & width now as on android phones a bug gives an incorrect screen.height when keyboard is shown
?>
<script type="text/javascript">dgn('userScreenWidth').value=screen.width;dgn('userScreenHeight').value=screen.height;</script>
</body></html>